diff -uwrN sourceold/scripts/tcw_player.cpp source/scripts/tcw_player.cpp
--- sourceold/scripts/tcw_player.cpp	2012-06-09 08:11:12.339843700 +0800
+++ source/scripts/tcw_player.cpp	2012-08-02 12:51:48.533203100 +0800
@@ -14,20 +14,24 @@
 #include "General.h"
 #include "scripts.h"
 #include "engine.h"
+#include "SoldierGameObj.h"
 #include "tcw_player.h"
 #ifdef SSGM
 #include "gmgame.h"
 #endif
 
+#pragma warning(disable: 4239)
+
 void tcw_Grant_Powerup_Created::Created(GameObject *obj)//with this script we can do to players what we want easily
 {
-	map_low_grav = false;	map_dm_tech1 = false;	map_dm_tech2 = false;	map_dm_tech3 = false;	map_coop_gdi = false;	map_coop_nod = false;	
+	map_low_grav = false;	map_dm_tech1 = false;	map_dm_tech2 = false;	map_dm_tech3 = false;	map_coop_gdi = false;	map_coop_nod = false;	map_sniper_only = false;
 	if (Find_Object_By_Preset(2,"TCW_Low_Grav_Map")) { map_low_grav = true; }
 	if (Find_Object_By_Preset(2,"TCW_DM_Tech1")) { map_dm_tech1 = true; }//no snipers, shadows and commando's
 	if (Find_Object_By_Preset(2,"TCW_DM_Tech2")) { map_dm_tech2 = true; }//no commando's
 	if (Find_Object_By_Preset(2,"TCW_DM_Tech3")) { map_dm_tech3 = true; }//no limitations
 	if (Find_Object_By_Preset(2,"TCW_Coop_Map_GDI")) { map_coop_gdi = true; }
 	if (Find_Object_By_Preset(2,"TCW_Coop_Map_Nod")) { map_coop_nod = true; }
+	if (Find_Object_By_Preset(2,"TCW_Sniper_Only_Map")) { map_sniper_only = true; }
 
 	if (map_coop_nod)
 	{
@@ -37,7 +41,13 @@
 	{
 		if (Commands->Get_Player_Type(obj) == 0)	{ Change_Team(obj,1); }
 	}
-
+	else if (map_sniper_only)
+	{
+		if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper") != 0)
+		{
+			Change_Character(obj,"TCW_GDI_Sniper");
+		}
+	}
 	if (map_dm_tech1)
 	{
 		int randomchargdi = Commands->Get_Random_Int(1,5);		int randomcharnod = Commands->Get_Random_Int(1,5);
@@ -217,7 +227,12 @@
 	if (Find_Object_By_Preset(2,"TCW_Tech_Composit_Armor_Available")) {	upgrade_composit_armor_available = true; }
 	if (Find_Object_By_Preset(2,"TCW_Tech_Power_Packs_Available")) { upgrade_powerpacks_available = true; }
 
-	int sniperlimit = 2;
+	int sniperlimit;
+	if (map_sniper_only) 
+	{ 
+		sniperlimit = 100; 
+	}
+	else sniperlimit = 2;
 
 	commandocurrpos.X = 0;	commandocurrpos.Y = 0;	commandocurrpos.Z = 0;
 	commandonewpos.X = 0;	commandonewpos.Y = 0;	commandonewpos.Z = 0;
@@ -233,10 +248,13 @@
 	}
 	else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper_Low") == 0) )
 	{
+		if (!map_sniper_only)
+		{
 		Commands->Enable_Stealth(obj,true);
 		commandocurrpos = Commands->Get_Position(obj);
 		Commands->Start_Timer(obj,this,1.0f,1006);//check move enable stealth
 	}
+	}
 
 	//grant weapon stuff when they spawn
 	const char *weapon1 = Get_Parameter("Weapon1");	const char *weapon2 = Get_Parameter("Weapon2");	const char *weapon3 = Get_Parameter("Weapon3");	const char *weapon4 = Get_Parameter("Weapon4");	const char *weapon5 = Get_Parameter("Weapon5");
@@ -247,7 +265,7 @@
 	if (_stricmp(weapon5,"0") != 0)	{ Commands->Give_PowerUp(obj,weapon5,false); }
 
 	//unit purchase sounds
-	int random = Commands->Get_Random_Int(1,3);//used by char purchase playsound
+	int random = Commands->Get_Random_Int(1,6);//used by char purchase playsound
 	if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Commando") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Commando_Low") == 0) )
 	{
 		if (Commands->Get_Player_Type(obj) == 1)
@@ -287,7 +305,7 @@
 					char player[250]; sprintf(player,"%s: Didn't miss anything, did i?.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
-				else if (rnd == 5)
+				else
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_5.wav",1);
 					char player[250]; sprintf(player,"%s: Let's load and lock and roll and rock.",Get_Player_Name(obj));
@@ -332,7 +350,7 @@
 					char player[250]; sprintf(player,"%s: Didn't miss anything, did i?.",Get_Player_Name(obj));
 					Send_Message_Team(0,255,0,0,player);
 				}
-				else if (rnd == 5)
+				else
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_5.wav",0);
 					char player[250]; sprintf(player,"%s: Let's load and lock and roll and rock.",Get_Player_Name(obj));
@@ -358,7 +376,7 @@
 				char player[250]; sprintf(player,"%s: Reporting in.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_3.wav",1);
 				char player[250]; sprintf(player,"%s: Rifleman awaiting orders.",Get_Player_Name(obj));
@@ -366,7 +384,8 @@
 			}
 			if (upgrade_composit_armor_available)
 			{
-				Change_Character(obj,"TCW_GDI_Rifle_Upgrade");
+				Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)+75.0f);
+				Commands->Set_Shield_Strength(obj,Commands->Get_Health(obj)+75.0f);
 			}
 		}
 		else if (Commands->Get_Player_Type(obj) == 0)
@@ -383,7 +402,7 @@
 				char player[250]; sprintf(player,"%s: Rifle squad ready.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_3.wav",0);
 				char player[250]; sprintf(player,"%s: Rifleman awaiting orders.",Get_Player_Name(obj));
@@ -406,7 +425,7 @@
 			char player[250]; sprintf(player,"%s: Rifle squad ready.",Get_Player_Name(obj));
 			Send_Message_Team(1,255,204,0,player);
 		}
-		else if (random == 3)
+		else
 		{
 			Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_3.wav",1);
 			char player[250]; sprintf(player,"%s: Rifleman awaiting orders.",Get_Player_Name(obj));
@@ -414,7 +433,8 @@
 		}
 		if (upgrade_composit_armor_available)
 		{
-			Change_Character(obj,"TCW_GDI_Rifle_Low_Upgrade");
+			Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)+75.0f);
+			Commands->Set_Shield_Strength(obj,Commands->Get_Health(obj)+75.0f);
 		}
 	}
 
@@ -434,7 +454,7 @@
 				char player[250]; sprintf(player,"%s: Engineer clocking in.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_3.wav",1);
 				char player[250]; sprintf(player,"%s: Engineer reporting in.",Get_Player_Name(obj));
@@ -455,7 +475,7 @@
 				char player[250]; sprintf(player,"%s: Engineer clocking in.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_3.wav",0);
 				char player[250]; sprintf(player,"%s: Engineer reporting in.",Get_Player_Name(obj));
@@ -479,15 +499,16 @@
 				char player[250]; sprintf(player,"%s: Somebody call for some blasting?",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_3.wav",1);
-				char player[250]; sprintf(player,"%s: Grenade squad all ready.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Pull your pins.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
-				Change_Character(obj,"TCW_GDI_Grenadier_Upgrade");
+				Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)+75.0f);
+				Commands->Set_Shield_Strength(obj,Commands->Get_Health(obj)+75.0f);
 			}
 		}
 		else if (Commands->Get_Player_Type(obj) == 0)
@@ -504,10 +525,10 @@
 				char player[250]; sprintf(player,"%s: Somebody call for some blasting?",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_3.wav",0);
-				char player[250]; sprintf(player,"%s: Grenade squad all ready.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Pull your pins.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
@@ -526,15 +547,16 @@
 			char player[250]; sprintf(player,"%s: Somebody call for some blasting?",Get_Player_Name(obj));
 			Send_Message_Team(1,255,204,0,player);
 		}
-		else if (random == 3)
+		else
 		{
 			Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_3.wav",1);
-			char player[250]; sprintf(player,"%s: Grenade squad all ready.",Get_Player_Name(obj));
+			char player[250]; sprintf(player,"%s: Pull your pins.",Get_Player_Name(obj));
 			Send_Message_Team(1,255,204,0,player);
 		}
 		if (upgrade_composit_armor_available)
 		{
-			Change_Character(obj,"TCW_GDI_Grenadier_Low_Upgrade");
+			Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)+75.0f);
+			Commands->Set_Shield_Strength(obj,Commands->Get_Health(obj)+75.0f);
 		}
 	}		
 		
@@ -554,7 +576,7 @@
 				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
 				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
@@ -562,7 +584,8 @@
 			}
 			if (upgrade_composit_armor_available)
 			{
-				Change_Character(obj,"TCW_GDI_Missile_Squad_Upgrade");
+				Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)+75.0f);
+				Commands->Set_Shield_Strength(obj,Commands->Get_Health(obj)+75.0f);
 			}
 		}
 		else if (Commands->Get_Player_Type(obj) == 0)
@@ -579,7 +602,7 @@
 				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",0);
 				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
@@ -601,7 +624,7 @@
 			char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
 			Send_Message_Team(1,255,204,0,player);
 		}
-		else if (random == 3)
+		else
 		{
 			Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
 			char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
@@ -609,7 +632,8 @@
 		}
 		if (upgrade_composit_armor_available)
 		{
-			Change_Character(obj,"TCW_GDI_Missile_Squad_Low_Upgrade");
+			Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)+75.0f);
+			Commands->Set_Shield_Strength(obj,Commands->Get_Health(obj)+75.0f);
 		}
 	}
 
@@ -638,10 +662,10 @@
 					char player[250]; sprintf(player,"%s: I got'm in my scope.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
-				else if (random == 3)
+				else
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_3.wav",1);
-					char player[250]; sprintf(player,"%s: Sniper team, where do you need us?",Get_Player_Name(obj));
+					char player[250]; sprintf(player,"%s: Need somebody taken out?",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
 			}
@@ -669,10 +693,10 @@
 					char player[250]; sprintf(player,"%s: Sniper team ready.",Get_Player_Name(obj));
 					Send_Message_Team(0,255,0,0,player);
 				}
-				else if (random == 3)
+				else
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_3.wav",0);
-					char player[250]; sprintf(player,"%s: Sniper team, where do you need us?",Get_Player_Name(obj));
+					char player[250]; sprintf(player,"%s: Need somebody taken out?",Get_Player_Name(obj));
 					Send_Message_Team(0,255,0,0,player);
 				}
 			}
@@ -705,6 +729,12 @@
 				char player[250]; sprintf(player,"%s: Troopers in the field.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
+			else
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_4.wav",1);
+				char player[250]; sprintf(player,"%s: Sit tight.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
+			}
 		}
 		else if (Commands->Get_Player_Type(obj) == 0)
 		{
@@ -726,6 +756,12 @@
 				char player[250]; sprintf(player,"%s: Troopers in the field.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
+			else
+			{
+				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_4.wav",0);
+				char player[250]; sprintf(player,"%s: Sit tight.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
 		}
 	}
 	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Commando") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Commando_Low") == 0) )
@@ -751,13 +787,13 @@
 				else if (random == 2)
 				{
 					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",0);
-					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					char player[250]; sprintf(player,"%s: It's play time.",Get_Player_Name(obj));
 					Send_Message_Team(0,255,0,0,player);
 				}
-				else if (random == 3)
+				else
 				{
-					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",0);
-					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					Create_2D_WAV_Sound_Team("purchase_nod_commando_3.wav",0);
+					char player[250]; sprintf(player,"%s: Sorry about the mess.",Get_Player_Name(obj));
 					Send_Message_Team(0,255,0,0,player);
 				}
 			}
@@ -783,13 +819,13 @@
 				else if (random == 2)
 				{
 					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",1);
-					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					char player[250]; sprintf(player,"%s: It's play time.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
-				else if (random == 3)
+				else
 				{
 					Create_2D_WAV_Sound_Team("purchase_nod_commando_3.wav",1);
-					char player[250]; sprintf(player,"%s: It's play time.",Get_Player_Name(obj));
+					char player[250]; sprintf(player,"%s: Sorry about the mess.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
 			}
@@ -817,6 +853,12 @@
 				char player[250]; sprintf(player,"%s: Fighters arm up.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
+			else
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_4.wav",0);
+				char player[250]; sprintf(player,"%s: Fight for Nod.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
+			}
 		}
 		else if (Commands->Get_Player_Type(obj) == 1)
 		{
@@ -836,7 +878,13 @@
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_3.wav",1);
 				char player[250]; sprintf(player,"%s: Fighters arm up.",Get_Player_Name(obj));
-				Send_Message_Team(0,255,204,0,player);
+				Send_Message_Team(1,255,204,0,player);
+			}
+			else
+			{
+				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_4.wav",1);
+				char player[250]; sprintf(player,"%s: Fight for Nod.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 		}
 	}
@@ -854,7 +902,7 @@
 			char player[250]; sprintf(player,"%s: The Black Hand is in control.",Get_Player_Name(obj));
 			Send_Message_Team(0,255,0,0,player);
 		}
-		else if (random == 3)
+		else
 		{
 			Create_2D_WAV_Sound_Team("purchase_nod_blackhand_chem_3.wav",0);
 			char player[250]; sprintf(player,"%s: The Black Hand has arrived.",Get_Player_Name(obj));
@@ -865,7 +913,7 @@
 	{
 		if (Commands->Get_Player_Type(obj) == 0)
 		{
-			int rnd = Commands->Get_Random_Int(1,4);
+			int rnd = Commands->Get_Random_Int(1,5);
 			if (rnd == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_1.wav",0);
@@ -884,16 +932,16 @@
 				char player[250]; sprintf(player,"%s: They cannot hide from the Black Hand.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (rnd == 4)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_4.wav",0);
-				char player[250]; sprintf(player,"%s: And then there was fire.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Spare no one.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
 		else if (Commands->Get_Player_Type(obj) == 1)
 		{
-			int rnd = Commands->Get_Random_Int(1,4);
+			int rnd = Commands->Get_Random_Int(1,5);
 			if (rnd == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_1.wav",1);
@@ -912,10 +960,10 @@
 				char player[250]; sprintf(player,"%s: The flame shall purify.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (rnd == 4)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_4.wav",1);
-				char player[250]; sprintf(player,"%s: And then there was fire.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Spare no one.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
 		}
@@ -936,7 +984,7 @@
 				char player[250]; sprintf(player,"%s: Rockets ready.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_3.wav",0);
 				char player[250]; sprintf(player,"%s: We got the rockets.",Get_Player_Name(obj));
@@ -957,7 +1005,7 @@
 				char player[250]; sprintf(player,"%s: Rockets ready.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_3.wav",1);
 				char player[250]; sprintf(player,"%s: We got the rockets.",Get_Player_Name(obj));
@@ -981,10 +1029,10 @@
 				char player[250]; sprintf(player,"%s: Need help with anything?",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
-				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_1.wav",0);
-				char player[250]; sprintf(player,"%s: The Brotherhood has entrusted me.",Get_Player_Name(obj));
+				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_3.wav",0);
+				char player[250]; sprintf(player,"%s: You can trust me.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
@@ -1002,10 +1050,10 @@
 				char player[250]; sprintf(player,"%s: Need help with anything?",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
-				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_1.wav",1);
-				char player[250]; sprintf(player,"%s: The Brotherhood has entrusted me.",Get_Player_Name(obj));
+				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_3.wav",1);
+				char player[250]; sprintf(player,"%s: You can trust me.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
 		}
@@ -1023,13 +1071,13 @@
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",0);
-				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: The wings of Nod.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",0);
-				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: The wings of Nod.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 		}
@@ -1044,13 +1092,13 @@
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",1);
-				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: The wings of Nod.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
-			else if (random == 3)
+			else
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",1);
-				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: The wings of Nod.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
 		}
@@ -1085,9 +1133,11 @@
 	}
 	else if (number == 1007)//used for zonetrooper repair powerpacks
 	{
+		if (!Get_Vehicle(obj))
+		{
 		commandonewpos = Commands->Get_Position(obj);
-		float commandotraveldistance = Commands->Get_Distance(commandocurrpos,commandonewpos);
-		if (commandotraveldistance <= 0.1f)	// not moved...
+			float zonetroopertraveldistance = Commands->Get_Distance(commandocurrpos,commandonewpos);
+			if (zonetroopertraveldistance <= 0.1f)	// not moved...
 		{
 			if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Zonetrooper") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Zonetrooper_Low") == 0) && (Commands->Get_Player_Type(obj) == 1))
 			{
@@ -1101,16 +1151,26 @@
 				}
 				if (curap < maxap)
 				{
-					Commands->Set_Health(obj,curap+5.0f);
+						Commands->Set_Shield_Strength(obj,curap+5.0f);
+					}
+					Commands->Start_Timer(obj,this,3.0f,1007);
+				}
 				}
+			else
+			{
+				commandocurrpos = Commands->Get_Position(obj);//new current position, moved..
 				Commands->Start_Timer(obj,this,3.0f,1007);
 			}
 		}
+		else
+		{
+			Commands->Start_Timer(obj,this,3.0f,1007);
+		}
 	}
 }
 void tcw_Grant_Powerup_Created::Killed(GameObject *obj, GameObject *shooter)
 {
-	Commands->Send_Custom_Event(obj,shooter,1003,1,0);
+	//placeholder
 }
 void tcw_Grant_Powerup_Created::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
@@ -1260,16 +1320,17 @@
 			float newhp = curhp + 30.0f; Commands->Set_Health(obj, newhp);
 			float newap = curap + 30.0f; Commands->Set_Shield_Strength(obj, newap);
 			Create_2D_WAV_Sound_Player(obj,"gdi_tech_unit_upgraded.wav");
-			Send_Message_Player(obj,255,204,0,"Unit Upgraded: Composite Armor.");
+			Send_Message_Player(obj,5,220,220,"Unit Upgraded: Composite Armor.");
 		}
 	}
 	else if (message == 1006)//Tech Powerpacks Upgrade complete
 	{
 		if (param == 1)
 		{
+			commandocurrpos = Commands->Get_Position(obj);
 			Commands->Start_Timer(obj,this,1.0f,1007);//start regeneration if not moved
 			Create_2D_WAV_Sound_Player(obj,"gdi_tech_unit_upgraded.wav");
-			Send_Message_Player(obj,255,204,0,"Unit Upgraded: Power Packs.");
+			Send_Message_Player(obj,5,220,220,"Unit Upgraded: Power Packs.");
 		}
 	}
 }
@@ -1288,4 +1349,34 @@
 	Auto_Save_Variable(&map_coop_nod,sizeof(map_coop_nod),11);
 }
 
+void tcw_fanatic::Created(GameObject *obj)
+{
+	if (!Commands->Is_A_Star(obj))
+	{
+		Destroy_Script();
+		return;
+	}
+	DetonateTime = Get_Float_Parameter("DetonateTime");
+	RunSpeed = Get_Float_Parameter("RunSpeed");
+	Explosion = Get_Parameter("Explosion");
+	InstallHook("FanaticExplode",obj);
+}
+
+void tcw_fanatic::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1)
+	{
+		Create_Explosion_Extended(Explosion,Commands->Get_Position(obj),obj);
+	}
+}
+
+void tcw_fanatic::KeyHook()
+{
+	RemoveHook();
+	Owner()->As_SoldierGameObj()->Set_Max_Speed(RunSpeed);
+	Owner()->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);
+	Commands->Start_Timer(Owner(),this,DetonateTime,1);
+}
+
+ScriptRegistrant<tcw_fanatic> tcw_fanatic_Registrant("tcw_fanatic","DetonateTime=30:float,RunSpeed=5:float,Explosion:string");
 ScriptRegistrant<tcw_Grant_Powerup_Created> tcw_Grant_Powerup_Created_Registrant("tcw_Grant_Powerup_Created","Weapon1=TCW_POW_Knife:string,Weapon2=0:string,Weapon3=0:string,Weapon4=0:string,Weapon5=0:string");
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_player.h source/scripts/tcw_player.h
--- sourceold/scripts/tcw_player.h	2012-06-09 08:11:12.169921800 +0800
+++ source/scripts/tcw_player.h	2012-08-02 12:51:48.537109300 +0800
@@ -31,6 +31,17 @@
 	bool map_dm_tech3;
 	bool map_coop_gdi;
 	bool map_coop_nod;
+	bool map_sniper_only;
 	Vector3 commandocurrpos;
 	Vector3 commandonewpos;
 };
\ No newline at end of file
+
+class tcw_fanatic : public JFW_Key_Hook_Base
+{
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+	void KeyHook();
+	float DetonateTime;
+	float RunSpeed;
+	const char *Explosion;
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_sp_m01.cpp source/scripts/tcw_sp_m01.cpp
--- sourceold/scripts/tcw_sp_m01.cpp	1970-01-01 08:00:00.000000000 +0800
+++ source/scripts/tcw_sp_m01.cpp	2012-08-05 10:29:24.416976500 +0800
@@ -0,0 +1,102 @@
+/*	Renegade Scripts.dll
+	Scripts from - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
+	under the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
+	with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
+
+#include "General.h"
+#include "engine.h"
+#include "scripts.h"
+#include "ScriptZoneGameObj.h"
+#include "VehicleGameObj.h"
+#include "tcw_sp_m01.h"
+
+void tcw_m01_objective_controller::Created(GameObject *obj)
+{
+	Commands->Enable_Radar(true);
+	spike_captured = false;
+	Vector3 spike_position = Commands->Get_Position(Commands->Find_Object(100017));
+	Commands->Set_Objective_HUD_Info_Position(1000,90,"POG_M04_1_01.tga",12778,spike_position );
+	Commands->Add_Objective(1000,OBJECTIVE_TYPE_PRIMARY,OBJECTIVE_STATUS_PENDING,12776,NULL,12777);
+	Commands->Add_Radar_Marker(1001,Commands->Get_Position(Commands->Find_Object(100017)),RADAR_BLIP_SHAPE_OBJECTIVE,RADAR_BLIP_COLOR_PRIMARY_OBJECTIVE);
+}
+void tcw_m01_objective_controller::Custom(GameObject *obj, int message, int param, GameObject *sender)
+{
+	if (message == 1000)
+	{
+		spike_captured = true;
+		Commands->Set_Objective_Status(1000,OBJECTIVE_STATUS_ACCOMPLISHED);
+		Commands->Clear_Radar_Marker(1001);
+		Commands->Start_Timer(obj,this,5.0f,1000);//complete mission
+	}
+}
+void tcw_m01_objective_controller::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1000)
+	{
+		Commands->Mission_Complete(true);
+	}
+}
+void tcw_m01_objective_controller::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&spike_captured,sizeof(spike_captured),1);
+}
+
+void tcw_m01_spike_zone::Entered(GameObject *obj, GameObject *enter)
+{
+	if (Commands->Is_A_Star(enter))
+	{
+		Commands->Create_2D_WAV_Sound("building_capture.wav");
+		Attach_Script_Once(enter,"tcw_m01_star_capturing_spike","");
+		Send_Message(255,255,255,"You are now capturing this Tiberium Spike.");
+	}
+}
+void tcw_m01_spike_zone::Exited(GameObject *obj, GameObject *exit)
+{
+	Remove_Script(exit,"tcw_m01_star_capturing_spike");
+	Send_Message(255,255,255,"You have stopped capturing this Tiberium Spike.");
+	Commands->Create_2D_WAV_Sound("incmsg.wav");
+}
+
+void tcw_m01_star_capturing_spike::Created(GameObject *obj)
+{
+	Commands->Start_Timer(obj,this,7.5f,1000);
+}
+void tcw_m01_star_capturing_spike::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1000)
+	{
+		Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_m01_spike"),1000,0,0);//enable animation on spike
+		Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_m01_objective_controller"),1000,0,0);//set objective accomplished
+		Commands->Create_2D_WAV_Sound("gdi_building_captured.wav");
+		Send_Message(255,255,255,"Building Captured");
+		Commands->Destroy_Object(Find_Object_With_Script("tcw_m01_spike_zone"));
+		Destroy_Script();
+	}
+}
+
+void tcw_m01_spike::Created(GameObject *obj)
+{
+	Commands->Set_Animation(obj,"V_NEU_SPIKE.V_NEU_SPIKE",true,0,0,0,0);
+}
+void tcw_m01_spike::Custom(GameObject *obj, int message, int param, GameObject *sender)
+{
+	if (message == 1000)
+	{
+		Commands->Set_Animation(obj,"V_NEU_SPIKE.V_NEU_SPIKE",true,0,1,-1,0);
+		Commands->Set_Player_Type(obj,1);
+	}
+}
+
+ScriptRegistrant<tcw_m01_spike> tcw_m01_spike_Registrant("tcw_m01_spike", "");
+ScriptRegistrant<tcw_m01_star_capturing_spike> tcw_m01_star_capturing_spike_Registrant("tcw_m01_star_capturing_spike", "");
+ScriptRegistrant<tcw_m01_spike_zone> tcw_m01_spike_zone_Registrant("tcw_m01_spike_zone", "");
+ScriptRegistrant<tcw_m01_objective_controller> tcw_m01_objective_controller_Registrant("tcw_m01_objective_controller", "");
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_sp_m01.h source/scripts/tcw_sp_m01.h
--- sourceold/scripts/tcw_sp_m01.h	1970-01-01 08:00:00.000000000 +0800
+++ source/scripts/tcw_sp_m01.h	2012-08-05 10:29:24.420882800 +0800
@@ -0,0 +1,38 @@
+/*	Renegade Scripts.dll
+	Scripts from - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
+	under the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
+	with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
+
+#pragma once
+
+class tcw_m01_objective_controller : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	bool spike_captured;
+};
+
+class tcw_m01_star_capturing_spike : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+};
+
+class tcw_m01_spike : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+};
+
+class tcw_m01_spike_zone : public ScriptImpClass {
+	void Entered(GameObject *obj, GameObject *enter);
+	void Exited(GameObject *obj, GameObject *exit);
+};
\ No newline at end of file
